package org.gcube.portlets.widgets.wstaskexecutor.client.event;

import org.gcube.common.workspacetaskexecutor.shared.dataminer.TaskConfiguration;
import org.gcube.portlets.widgets.wstaskexecutor.shared.WsFolder;

import com.google.gwt.event.shared.GwtEvent;


// TODO: Auto-generated Javadoc
/**
 * The Class PerformDoSyncEvent.
 *
 * @author Francesco Mangiacrapa francesco.mangiacrapa@isti.cnr.it
 * Feb 15, 2018
 */
public class PerformRunTaskEvent extends GwtEvent<PerformRunTaskEventHandler> {

	/** The type. */
	public static Type<PerformRunTaskEventHandler> TYPE = new Type<PerformRunTaskEventHandler>();
	private TaskConfiguration conf;
	private WsFolder folder;


	/**
	 * Instantiates a new perform do sync event.
	 *
	 * @param folder the folder
	 * @param conf the conf
	 */
	public PerformRunTaskEvent(WsFolder folder, TaskConfiguration conf) {
		this.folder = folder;
		this.conf = conf;

	}

	/* (non-Javadoc)
	 * @see com.google.gwt.event.shared.GwtEvent#getAssociatedType()
	 */
	@Override
	public Type<PerformRunTaskEventHandler> getAssociatedType() {
		return TYPE;
	}

	/* (non-Javadoc)
	 * @see com.google.gwt.event.shared.GwtEvent#dispatch(com.google.gwt.event.shared.EventHandler)
	 */
	@Override
	protected void dispatch(PerformRunTaskEventHandler handler) {
		handler.onPerformRunTask(this);
	}


	/**
	 * Gets the conf.
	 *
	 * @return the conf
	 */
	public TaskConfiguration getConf() {
		return conf;

	}

	public WsFolder getFolder() {
		return folder;
	}

}
