package org.gcube.portlets.widgets.wstaskexecutor.client.rpc;

import java.util.List;

import org.gcube.common.workspacetaskexecutor.shared.dataminer.TaskConfiguration;
import org.gcube.common.workspacetaskexecutor.shared.exception.ItemNotConfiguredException;
import org.gcube.portlets.widgets.wstaskexecutor.shared.GcubeScope;

import com.google.gwt.user.client.rpc.RemoteService;
import com.google.gwt.user.client.rpc.RemoteServiceRelativePath;


/**
 * The Interface GreetingService.
 *
 * @author Francesco Mangiacrapa francesco.mangiacrapa@isti.cnr.it
 * May 4, 2018
 */
@RemoteServiceRelativePath("greet")
public interface WsTaskExecutorWidgetService extends RemoteService {

	/**
	 * Gets the list of scopes for logged user.
	 *
	 * @return the list of scopes for logged user
	 * @throws Exception the exception
	 */
	List<GcubeScope> getListOfScopesForLoggedUser() throws Exception;

	/**
	 * Check item task configurations.
	 *
	 * @param itemId the item id
	 * @return the list
	 * @throws ItemNotConfiguredException, Exception
	 */
	List<TaskConfiguration> checkItemTaskConfigurations(String itemId) throws ItemNotConfiguredException, Exception;
}
