/**
 *
 */
package org.gcube.portlets.widgets.wstaskexecutor.client.rpc;

import java.util.List;

import org.gcube.common.workspacetaskexecutor.shared.dataminer.TaskComputation;
import org.gcube.common.workspacetaskexecutor.shared.dataminer.TaskConfiguration;
import org.gcube.common.workspacetaskexecutor.shared.dataminer.TaskExecutionStatus;
import org.gcube.portlets.widgets.wstaskexecutor.shared.GcubeScope;

import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;



/**
 * The Interface WsTaskExecutorWidgetServiceAsync.
 *
 * @author Francesco Mangiacrapa francesco.mangiacrapa@isti.cnr.it
 * May 4, 2018
 */
public interface WsTaskExecutorWidgetServiceAsync {


    /**
     * The Class Util.
     *
     * @author Francesco Mangiacrapa francesco.mangiacrapa@isti.cnr.it
     * May 4, 2018
     */
    public static final class Util
    {
        private static WsTaskExecutorWidgetServiceAsync instance;

        /**
         * Gets the single instance of Util.
         *
         * @return single instance of Util
         */
        public static final WsTaskExecutorWidgetServiceAsync getInstance()
        {
            if ( instance == null )
            {
                instance = (WsTaskExecutorWidgetServiceAsync) GWT.create( WsTaskExecutorWidgetService.class );
            }
            return instance;
        }

        /**
         * Instantiates a new util.
         */
        private Util()
        {
            // Utility class should not be instantiated
        }
    }

	/**
	 * Gets the list of scopes for logged user.
	 *
	 * @param asyncCallback the async callback
	 * @return the list of scopes for logged user
	 */
	void getListOfScopesForLoggedUser(AsyncCallback<List<GcubeScope>> asyncCallback);

	/**
	 * Check item task configurations.
	 *
	 * @param folderId the folder id
	 * @param asyncCallback the async callback
	 */
	void checkItemTaskConfigurations(String folderId, AsyncCallback<List<TaskConfiguration>> asyncCallback);


	/**
	 * Monitor task execution status.
	 *
	 * @param configuration the configuration
	 * @param taskComputation the task computation
	 * @param asyncCallback the async callback
	 */
	void monitorTaskExecutionStatus(
		TaskConfiguration configuration, TaskComputation taskComputation,
		AsyncCallback<TaskExecutionStatus> asyncCallback);
}
